Fix mountpoint after full fs transfer if needed
[zfs-ubuntu/.git] / zfs-autosnap
index da650f53362fc2a35dca67aef2be9974b0f7aac4..4c26aa9404ea5ed07b5965f4296bd38494e386e0 100755 (executable)
@@ -66,20 +66,15 @@ if [ -z "$SNAP_UNDER_TEST" -a ! -d "$mountpoint" ]; then
 fi
 
 if [ -n "$SNAP_UNDER_TEST" ]; then
-    snapshotdir="./snapshot"
+    snapshots=$(ls -d ./snapshot/????-??-??.??.?? 2>/dev/null)
 else
-    snapshotdir="${mountpoint}/.zfs/snapshot"
-fi
-
-if [ ! -d "$snapshotdir" ]; then
-   echo "-E- Unable to find the snapshotdir: $snapshotdir"
-   exit 1
+    snapshots=$(zfs list -H -t snapshot -o name $filesystem | grep -P "\d+-\d+\.\d+\.\d+")
 fi
 
 # Check to see if this zfs filesystem has a scrub being performed on it now.
 # If it does, we cannot perform any snapshot create or destroy operations.
 if [ -z "$SNAP_UNDER_TEST" ]; then
-    zpool status $pool | grep scrub: | grep "in progress" > /dev/null 2>&1
+    zpool status $pool | grep scan: | grep "in progress" > /dev/null 2>&1
     if [ $? == 0 ]; then
        echo "-W- The zfs pool '$pool' is currently being scrubbed. Skipping all snapshot operations."
        exit 0
@@ -121,7 +116,6 @@ cleanup() { rm -rf "$lockdir"; }
 trap cleanup EXIT
 
 # Trim them down
-snapshots=$(ls -d ${snapshotdir}/????-??-??.??.?? 2>/dev/null)
 for snapshot in $snapshots; do
   snapminutes=$(echo "$snapshot" | sed 's,.*/,,' | datetime_to_minutes)
   snapminutes2=$(echo "$snapshot" | sed 's,.*/,,' | datetime_to_minutes2)
@@ -131,19 +125,13 @@ for snapshot in $snapshots; do
     if [ $age -lt $((window * numsnapshots)) ]; then
       case $((snapminutes2 % window)) in
         0) ;;
-        *)
-          snapname=${filesystem}$(echo "$snapshot" |
-                                  sed 's,/\(.*\)/.zfs/snapshot/\(.*\),@\2,')
-          destroy "$snapname"
-        ;;
+        *) destroy "$snapshot" ;;
       esac
       break
     fi
     window=$((window*2))
   done
   if [ $maxagedays -gt 0 ] && [ $age -gt $((maxagedays * 24 * 60)) ]; then
-    snapname=${filesystem}$(echo "$snapshot" |
-                            sed 's,/\(.*\)/.zfs/snapshot/\(.*\),@\2,')
-    destroy "$snapname"
+    destroy "$snapshot"
   fi
 done